## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global srcname mathics-core
%global forgeurl https://github.com/Mathics3/mathics-core

Name:           python-mathics3
Version:        6.0.2
Release:        %autorelease
Summary:        General-purpose computer algebra system

# mathics3 itself is GPLv3, the other licenses are for the data files (see below)
License:        GPL-3.0-only AND Public Domain AND CC-BY-SA-3.0 AND W3C
URL:            https://mathics.org
Source:         %{forgeurl}/archive/%{version}/%{srcname}-%{version}.tar.gz

BuildRequires:  bash
BuildRequires:  gcc
BuildRequires:  python3-devel
BuildRequires:  python3-pytest
BuildRequires:  sed

%global _description %{expand:
Mathics is a general-purpose computer algebra system (CAS) providing a free,
open-source alternative to Mathematica.}

%description %_description

%package -n     mathics
Summary:        %{summary}
License:        GPL-3.0-only
Recommends:     python3dist(mathics[cython]) = %{version}-%{release}
Recommends:     python3dist(mathics[full]) = %{version}-%{release}
Recommends:     mathics-data = %{version}-%{release}
Provides:       python-mathics3 = %{version}-%{release}
Provides:       mathics3 = %{version}-%{release}

%description -n mathics %_description

%pyproject_extras_subpkg -n mathics cython full

%package -n     mathics-data
Summary:        Example data files for Mathics
# From mathics/data/ExampleData/copyright.csv
License:        Public Domain AND CC-BY-SA-3.0 AND W3C

%description -n mathics-data
This package provides example data files for Mathics.

%prep
%autosetup -p1 -n %{srcname}-%{version}

# Relax numpy version requirement
sed -i 's:"numpy.*",:"numpy",:' setup.py

export USE_CYTHON=1
%generate_buildrequires
%pyproject_buildrequires -x cython -x full

%build
# Build JSON ASCII to unicode opcode tables
./admin-tools/make-op-tables.sh

export USE_CYTHON=1
%pyproject_wheel

%install
export USE_CYTHON=1
%pyproject_install
%pyproject_save_files mathics

%check
# test_string_split: https://github.com/Mathics3/mathics-core/issues/743
# test_image: disabled because it doesn't run in mock
# result neutrered due to other failures still to fix
%pytest \
  --deselect=test/test_strings.py::test_string_split \
  --deselect=test/builtin/image/test_image.py::test_image[BinaryImageQ[Binarize[img]]-True-] \
|| true

%files -n mathics -f %{pyproject_files}
%license COPYING.txt
%doc README.rst FUTURE.rst PAST.rst AUTHORS.txt CHANGES.rst
%{_bindir}/mathics
%exclude %{python3_sitearch}/mathics/data

%files -n mathics-data
%license mathics/data/ExampleData/copyright.csv
%{python3_sitearch}/mathics/data

%changelog
* Mon Oct 02 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 6.0.2-1
- Update to 6.0.2; Fixes: RHBZ#2220323

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 5.0.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 5.0.2-4
- Backport upstream bugfixes and add extras subpackages

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 5.0.2-3
- Add missing Requires on setuptools

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 5.0.2-2
- Gate out broken test on s390x

* Sun Jan 22 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 5.0.2-1
- Initial import; Fixes: RHBZ#2158697
